# 备份还原
## 概 述
备份还原用于对系统或用户数据进行备份和还原。该工具支持新建备份点，也支持在某个备份点上进行增量备份；支持将系统还原到某次备份时的状态，或者在保留某些数据的情况下进行部分还原。

备份还原有2种模式：常规模式、Grub备份还原。

<br>

## 常规模式
### 系统备份

![图 1 系统备份-big](image/1.png)


- **新建系统备份** —— 将除/backup、/media、/run、/proc、/dev、/sys、/cdrom、/mnt等目录外的整个文件系统中的数据(包含用户数据)进行备份。

选择新建后，点击 “开始备份” ，会弹出一个对话框，供用户指定设备进行系统备份，如图2所示。

![图 2 系统备份设备选择 -big](image/2.png)	

当确定进入备份时，系统查找备份还原分区是否有足够的空间来进行本次备份。若没有足够空间，则会有报错弹窗；若有足够空间，则会依次给出提示。
 
![图 3 备份提示-big](image/3.png)
![图 4 备份提示-big](image/4.png)

按“继续”按钮，则会在备份还原分区上新建一个备份。在备份过程中，会有如下所示的提示框。备份时间长短与备份内容大小有关。

![图 5 正在备份 -big](image/5.png)

系统备份标签页中“开始备份”旁边的“备份管理”，可用来查看系统备份状态，删除无效备份。

![图 6 系统备份管理-big](image/6.png)

- **系统增量备份** —— 在一个已有备份的基础上，继续进行备份。

当选择增量备份后，会弹出一个列出了所有备份的对话框，供用户选择。

可以在失败的备份基础上进行增量备份。

### 系统还原
“系统还原” 可将系统还原到以前一个备份时的状态。注意：如果不勾选“保留用户数据”，则会还原系统所有数据（包括用户数据）；系统还原是将系统还原到以前的某个备份时的状态，必然会删除此备份点后变化的数据，请注意备份重要数>据。

![图 7 系统还原-big](image/7.png)


点击“一键还原”，会弹出一个对话框，供用户指定还原的备份点。还原成功后，系统会自动重启。

### 数据备份与数据还原
- **数据备份** —— 对用户指定的目录或文件进行备份，功能与系统备份相似。注：``、$()、;、&、|等可以包含并执行系统命令或用于连续执行系统命令的符号加入黑名单，在备份前对要备份的目录名称进行判断，若包含有黑名单中的符号，则不允许进行备份。

![图 8 数据备份主界面-big](image/8.png)

选择“新建数据备份”后，点击“开始备份”，会弹出一个对话框，供用户指定需要备份的目录或文件，如图9所示，会对 /home/kylin/ 目录中的内容进行备份。

![图 9 指定数据备份目录 -big](image/9.png)

“开始备份”旁边的“备份管理”，可用来查看数据备份状态，删除无效备份。

- **数据增量备份** —— 在某个数据备份的基础上，增加需要备份的数据。

- **数据还原** —— 还原到某个数据备份的状态，功能与系统还原相似。

![图 10 数据还原主界面-big](image/10.png)

完成还原后，系统会自动重启。

### 操作日志
记录了在备份还原上的所有操作，主界面如图所示。可通过“上一页” 、“下一页”按钮进行翻页查看。

![图 11 操作日志主界面-big](image/11.png)

### Ghost镜像
Ghost镜像安装，是指将一台机器上的系统生成一个镜像文件，然后使用该镜像文件来安装操作系统。要使用该功能，首先需要有一个备份。

#### 创建Ghost镜像
选择菜单“Ghost镜像”，如图12所示。

![图 12 Ghost镜像主界面-big](image/12.png)

点击“一键Ghost”后，会弹出当前所有备份的列表；用户选择一个备份，点击“确定”后，开始制作Ghost镜像。镜像文件名的格式为“主机名+体系架构+备份名称.kyimg”；其中，备份名称只保留了数字。

如图13-1/13-2所示。

![图 13-1 Ghost镜像选择制作-big](image/13-1.png)
![图 13-2 Ghost镜像选择制作-big](image/13-2.png)

#### 安装Ghost镜像
1）把制作好的Ghost镜像（存在于“/ghost”目录下）拷贝到U盘等可移动存储设备。

2）进入Live系统后，接入可移动设备。

3）若设备没有自动挂载，可通过终端，手动将设备挂载到/mnt目录下：

“sudo mount /dev/sdb1 /mnt”

通常情况下，移动设备为/dev/sdb1，可使用命令“fdisk -l”查看。

4）双击安装图标，开始安装引导。在“安装方式”中选择“从Ghost镜像安装”，并找到移动设备中的Ghost镜像文件。后续步骤可参考“系统安装”部分。

![图 14 Ghost安装-big](image/14.png)

Tips：如果制作镜像文件时带有数据盘，则在下一步“安装类型”中也要“创建数据盘”。

<br>

## Grub备份还原
1）开机启动系统时，在Grub菜单选择系统备份还原模式。

2）备份模式：系统立即开始备份，屏幕上会给出提示。

对于备份模式而言，等同于常规模式下的“新建系统备份”。如果备份还原分区没有足够空间，则无法成功备份。

3）还原模式：系统立即开始还原到最近一次的成功备份状态，屏幕上会给出提示。

对于还原模式而言，等同于常规模式下的“一键还原”。如果备份还原分区上没有一个成功的备份，则系统不能被还原。

<br>

## 常见问题
### 无法使用备份还原
在安装操作系统时，必须要选中“创建备份还原分区”，备份还原才能使用。

### 可以对data分区和backup分区进行备份吗？
数据分区（/data）保存的内容与系统关系不大，且通常容量很大，因此不建议对数据分区进行备份和还原, 建议对系统进行一个初装备份，后面做小批量的重要数据的数据备份。

备份还原分区（/backup）用于保存和恢复其他分区的数据，故此分区的数据不允许备份或还原。
